<script setup lang="ts">
    import { CarlConfigurationIntervention } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationIntervention'
    import { computed, ref, WritableComputedRef, onMounted, watch } from 'vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import SJsonField from '@/shared/formField/components/SJsonField.vue'
    import SArrayOfStringField from '@/shared/formField/components/SArrayOfStringField.vue'
    import { CarlClientApi } from '@/shared/carl/entitites/carlClient/CarlClientApi'
    import { CarlClient } from '@/shared/carl/entitites/carlClient/CarlClient'
    import { CostCenter } from '@/shared/carl/entitites/configurationCarlObject/CostCenter'
    import { isDefined } from '@/shared/helpers/types'
    import { VolatileRef } from '@/shared/helpers/lifeCycle'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { onUnmounted } from 'vue'

    interface Props {
        modelValue: Partial<CarlConfigurationIntervention>
        loading: boolean
    }

    const props = defineProps<Props>()

    const emit = defineEmits<{
        'update:modelValue': [value: Partial<CarlConfigurationIntervention>]
    }>()

    const carlConfigurationIntervention: WritableComputedRef<
        Partial<CarlConfigurationIntervention>
    > = computed({
        get() {
            return props.modelValue
        },
        set(carlConfigurationIntervention) {
            emit('update:modelValue', carlConfigurationIntervention)
        },
    })

    const msal = useMsal()

    const carlClientApi = new CarlClientApi(msal)
    const costCentersFetchAborter: RequestAborter = new RequestAborter()

    const carlClients: VolatileRef<CarlClient[]> = ref({
        complete: false,
        data: [],
    })

    type CostCenterAndSelectLabel = CostCenter & { selectLabel: string }
    const costCenters: VolatileRef<CostCenterAndSelectLabel[]> = ref({
        complete: true,
        data: [],
    })

    onMounted(() => {
        try {
            carlClientApi.getAll().then((carlClientsData) => {
                carlClients.value = {
                    complete: true,
                    data: carlClientsData,
                }
            })
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
        }
    })
    onUnmounted(() => {
        costCentersFetchAborter.abortRequests()
    })

    const formIsValid = ref<boolean>(false)

    const rules = {
        hasTitle: (input: string | undefined) =>
            !!input || 'Vous devez renseigner un titre',
        hasPhotoAvantIntervention: (input: string | undefined) =>
            !!input || 'Vous devez renseigner un id',
        hasPhotoAprèsIntervention: (input: string | undefined) =>
            !!input || 'Vous devez renseigner un id',
        hasClientCarl: (input: CarlClient | undefined) =>
            !!input || 'Vous devez renseigner un client Carl',
    }

    const carlAttributesPresetForInterventionCreationPlaceholder = `{"xtraTxt06":"PROPRETE"}`
    const carlRelationshipsPresetForInterventionCreationPlaceholder = `{
        "costcenter": {"id":"14862472062-29e5","type":"actor"}
    }`
    const carlAttributesPresetForDemandeInterventionCreationPlaceholder = `{
        "xtraTxt06": "IMMOBILIER",
        "poiXtraTxt14": "POITIERS",
        "xtraTxt01": "DI_GEN"
    }`
    const carlRelationshipsPresetForDemandeInterventionCreationPlaceholder = `{
        "addressee": {"id":"14862472062-29e5","type":"actor"}
    }`

    const actionTypesMap = computed({
        get() {
            if (carlConfigurationIntervention.value.actionTypesMap) {
                return Object.entries(
                    carlConfigurationIntervention.value.actionTypesMap
                )
            } else {
                return []
            }
        },
        set(actionTypesArray: [string, string][]) {
            carlConfigurationIntervention.value.actionTypesMap =
                Object.fromEntries(actionTypesArray)
        },
    })

    watch(
        () => carlConfigurationIntervention.value.carlClient,
        () => {
            if (isDefined(carlConfigurationIntervention.value.carlClient)) {
                costCenters.value = {
                    complete: false,
                    data: [],
                }
                costCentersFetchAborter.abortRequestsAndRefreshAborter()
                carlClientApi
                    .getAllCostCenters(
                        carlConfigurationIntervention.value.carlClient.id.toString(),
                        costCentersFetchAborter.getSignal()
                    )
                    .then((costCentersData) => {
                        costCenters.value = {
                            complete: true,
                            data: (
                                costCentersData as CostCenterAndSelectLabel[]
                            ).map((costCenter) => {
                                costCenter.selectLabel = `${costCenter.label} - ${costCenter.code}`
                                return costCenter
                            }),
                        }
                    })
                    .catch((error) => {
                        if (error.name !== 'AbortError') {
                            emitSnackBar((<Error>error).message, 'error')
                        }
                    })
            }
        },
        { immediate: true }
    )

    function subPathHint(subPath: string) {
        return `Valeur par défaut issue du client ${carlConfigurationIntervention.value.carlClient?.title} : ${subPath}`
    }
</script>

<template>
    <v-form v-model="formIsValid">
        <v-row>
            <v-col cols="12">
                <v-textarea
                    v-model="carlConfigurationIntervention.notes"
                    label="Notes pour les administrateurs"
                    variant="outlined"
                    class="mb-3"
                    data-cy="carl-config-notes"
                    hide-details="auto"
                ></v-textarea>
            </v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="carlConfigurationIntervention.title"
                    label="Titre*"
                    class="mb-3"
                    :rules="[rules.hasTitle]"
                    data-cy="carl-config-title"
                    hide-details="auto"
                ></v-text-field>
            </v-col>
            <v-col cols="12">
                <v-select
                    v-model="carlConfigurationIntervention.carlClient"
                    :loading="!carlClients.complete"
                    label="Client carl*"
                    :items="carlClients.data"
                    return-object
                    variant="outlined"
                    class="mb-3"
                    :rules="[rules.hasClientCarl]"
                    data-cy="carlClient"
                    hide-details="auto"
                ></v-select
            ></v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="
                        carlConfigurationIntervention.photoAvantInterventionDoctypeId
                    "
                    label="Id type photo pré-intervention*"
                    class="mb-3"
                    :rules="[rules.hasPhotoAvantIntervention]"
                    data-cy="photoAvantInterventionDoctypeId"
                    hide-details="auto"
                ></v-text-field
            ></v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="
                        carlConfigurationIntervention.photoApresInterventionDoctypeId
                    "
                    label="Id type photo post-intervention*"
                    class="mb-3"
                    :rules="[rules.hasPhotoAprèsIntervention]"
                    data-cy="photoApresInterventionDoctypeId"
                    hide-details="auto"
                ></v-text-field
            ></v-col>
            <v-col cols="12">
                <s-array-of-string-field
                    v-model="
                        carlConfigurationIntervention.includeEquipementsChildrenWithType
                    "
                    label="Types d'équipements à inclure"
                    :format-help="'zone\nbuilding'"
                    data-cy="includeEquipementsChildrenWithType"
                />
            </v-col>
            <v-col cols="12">
                <h2>Paramètres des OT</h2>
            </v-col>
            <v-col cols="12">
                <s-array-of-string-field
                    v-model="carlConfigurationIntervention.directions"
                    label="Directions pour filtrer les interventions"
                    :format-help="'180f2f264b3-35ll3\n587f2f264b3-35f6l'"
                    data-cy="directions"
                    hint="Seules les OT qui possède une de ces valeur dans le champ cswo_wo.supervisor_id seront récupérées dans la vue carte"
                    persistent-hint
                />
            </v-col>
            <v-col v-if="carlConfigurationIntervention.carlClient" cols="12">
                <v-autocomplete
                    v-model="actionTypesMap"
                    label="Natures"
                    variant="outlined"
                    class="mb-3"
                    :items="
                        Object.entries(
                            carlConfigurationIntervention.carlClient
                                .availableActionTypes
                        )
                    "
                    item-title="1"
                    return-object
                    multiple
                    clearable
                    chips
                    data-cy="natures"
                    hide-details="auto"
                ></v-autocomplete
            ></v-col>
            <v-col v-if="carlConfigurationIntervention.carlClient" cols="12">
                <v-autocomplete
                    v-model="
                        carlConfigurationIntervention.interventionCostCenterIdsFilter
                    "
                    :loading="!costCenters.complete"
                    label="Centre de coûts pour filtrer les interventions"
                    class="mb-3"
                    :items="costCenters.data"
                    item-title="selectLabel"
                    item-value="id"
                    multiple
                    clearable
                    chips
                    closable-chips
                    data-cy="interventionCostCenterIdsFilter"
                    hide-details="auto"
                >
                </v-autocomplete>
            </v-col>
            <v-col v-if="carlConfigurationIntervention.carlClient" cols="12">
                <v-autocomplete
                    v-model="
                        carlConfigurationIntervention.costCenterIdForInterventionCreation
                    "
                    :loading="!costCenters.complete"
                    label="Centre de coût pour la création d'intervention"
                    class="mb-3"
                    :items="costCenters.data"
                    item-title="selectLabel"
                    item-value="id"
                    data-cy="costCenterIdForInterventionCreation"
                    hide-details="auto"
                    hint="Si ce champ n'est pas rempli, il y a un risque que la création d'intervention ne soit pas possible"
                    persistent-hint
                ></v-autocomplete
            ></v-col>
            <v-col cols="12">
                <v-switch
                    v-model="
                        carlConfigurationIntervention.useEquipmentCostCenterForInterventionCreation
                    "
                    label="Utiliser le centre de coût de l'équipement en priorité pour les interventions"
                    color="primary"
                ></v-switch>
            </v-col>
            <v-col cols="12">
                <s-json-field
                    v-model="
                        carlConfigurationIntervention.carlAttributesPresetForInterventionCreation
                    "
                    label="Attributs prédéfinis pour les OT"
                    :json-help="
                        carlAttributesPresetForInterventionCreationPlaceholder
                    "
                    json-help-description="Ces attributs seront ajoutés à la OT lors de sa création."
                    data-cy="carlAttributesPresetForInterventionCreation"
                />
            </v-col>
            <v-col cols="12">
                <s-json-field
                    v-model="
                        carlConfigurationIntervention.carlRelationshipsPresetForInterventionCreation
                    "
                    label="Relations prédéfinies pour les OT"
                    :json-help="
                        carlRelationshipsPresetForInterventionCreationPlaceholder
                    "
                    json-help-description="Ces relations seront ajoutés à l'OT lors de sa création."
                    data-cy="carlRelationshipsPresetForInterventionCreation"
                />
            </v-col>
            <v-col cols="12">
                <h2>Paramètres des DI</h2>
            </v-col>
            <v-col cols="12">
                <s-json-field
                    v-model="
                        carlConfigurationIntervention.carlAttributesPresetForDemandeInterventionCreation
                    "
                    label="Attributs prédéfinis pour les DI"
                    :json-help="
                        carlAttributesPresetForDemandeInterventionCreationPlaceholder
                    "
                    json-help-description="Ces attributs seront ajoutés à la DI lors de sa création."
                    data-cy="carlAttributesPresetForDemandeInterventionCreation"
                />
            </v-col>
            <v-col cols="12">
                <s-json-field
                    v-model="
                        carlConfigurationIntervention.carlRelationshipsPresetForDemandeInterventionCreation
                    "
                    label="Relations prédéfinies pour les DI"
                    :json-help="
                        carlRelationshipsPresetForDemandeInterventionCreationPlaceholder
                    "
                    json-help-description="Ces relations seront ajoutés à la DI lors de sa création."
                    data-cy="carlRelationshipsPresetForDemandeInterventionCreation"
                />
            </v-col>
            <v-col cols="12">
                <h2>Liens vers Carl</h2>
            </v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="carlConfigurationIntervention.woViewUrlSubPath"
                    label="Sous lien Carl pour OT"
                    class="mb-3"
                    data-cy="woViewUrlSubPath"
                    hide-details="auto"
                    :hint="
                        isDefined(
                            carlConfigurationIntervention.carlClient
                                ?.woViewUrlSubPath
                        )
                            ? subPathHint(
                                  carlConfigurationIntervention.carlClient
                                      .woViewUrlSubPath
                              )
                            : undefined
                    "
                    persistent-hint
                    prepend-icon="mdi-link"
                ></v-text-field>
            </v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="carlConfigurationIntervention.mrViewUrlSubPath"
                    label="Sous lien Carl pour DI"
                    class="mb-3"
                    data-cy="mrViewUrlSubPath"
                    hide-details="auto"
                    :hint="
                        isDefined(
                            carlConfigurationIntervention.carlClient
                                ?.mrViewUrlSubPath
                        )
                            ? subPathHint(
                                  carlConfigurationIntervention.carlClient
                                      .mrViewUrlSubPath
                              )
                            : undefined
                    "
                    persistent-hint
                    prepend-icon="mdi-link"
                ></v-text-field>
            </v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="carlConfigurationIntervention.boxViewUrlSubPath"
                    label="Sous lien Carl pour Point de structure"
                    class="mb-3"
                    data-cy="boxViewUrlSubPath"
                    hide-details="auto"
                    :hint="
                        isDefined(
                            carlConfigurationIntervention.carlClient
                                ?.boxViewUrlSubPath
                        )
                            ? subPathHint(
                                  carlConfigurationIntervention.carlClient
                                      .boxViewUrlSubPath
                              )
                            : undefined
                    "
                    persistent-hint
                    prepend-icon="mdi-link"
                ></v-text-field>
            </v-col>
            <v-col cols="12">
                <v-text-field
                    v-model="
                        carlConfigurationIntervention.materialViewUrlSubPath
                    "
                    label="Sous lien Carl pour Matériel"
                    class="mb-3"
                    data-cy="materialViewUrlSubPath"
                    hide-details="auto"
                    :hint="
                        isDefined(
                            carlConfigurationIntervention.carlClient
                                ?.materialViewUrlSubPath
                        )
                            ? subPathHint(
                                  carlConfigurationIntervention.carlClient
                                      .materialViewUrlSubPath
                              )
                            : undefined
                    "
                    persistent-hint
                    prepend-icon="mdi-link"
                ></v-text-field>
            </v-col>
        </v-row>

        <p class="text-right">
            <s-action-button
                icon="mdi-check"
                label="Enregistrer"
                :disabled="!formIsValid"
                :loading="loading"
                type="submit"
                data-cy="submit"
            >
            </s-action-button>
        </p>
    </v-form>
</template>
